#include "encryption.h"


using namespace std;

ofstream myfile_en;


mzd_t *mat_P; 
mzd_t *mat_Q;
mzd_t *mat_S0;
mzd_t *mat_S1;

mzd_t *vec_key;
mzd_t *vec_IS;
mzd_t *vec_keystream;
mzd_t *vec_message;
mzd_t *vec_ciphertext;

bool IV[80];

int L;

void initilize_quadraticSystem_key_IV()
{
 static int rows=D,cols=n;
	
	mat_P  =  mzd_init(rows,cols);
	mat_Q  =  mzd_init(rows,cols);
	mat_S0  = mzd_init(rows,cols);
	mat_S1  = mzd_init(rows,cols);
	
	vec_key= mzd_init(1,cols);

	mzd_randomize(mat_P);
	mzd_randomize(mat_Q);
	mzd_randomize(mat_S0);
	mzd_randomize(mat_S1);
	
	mzd_randomize(vec_key);

	for(int i=0;i<80;i++)
		IV[i]=rand()%2;
	

}

void initialize_message()
{	
	
 static int message_size =n*L;

	vec_message= mzd_init(1,message_size);

	mzd_randomize(vec_message);
	
}

void preprocessing()
{	
		
	vec_IS = mzd_copy(NULL, vec_key);
	

	for(int i=0;i<80;i++)
	{
		if (IV[i]==0)
			vec_IS = polynomial_evaluation(mat_S0,  vec_IS);
		else
			vec_IS = polynomial_evaluation(mat_S1,  vec_IS);		
		
	}



	for(int i=0;i<80;i++)
		vec_IS = polynomial_evaluation(mat_P,  vec_IS);

	
}


void keystream_generation()
{
	preprocessing();
	vec_keystream=polynomial_evaluation(mat_Q,  vec_IS);


	for(int i=0;i<(L-1);i++)
	{	
	

		vec_IS = polynomial_evaluation(mat_P,  vec_IS);


		vec_keystream = mzd_concat(NULL,vec_keystream, polynomial_evaluation(mat_Q,  vec_IS));
		
	}

	
}

void encryption()
{
	
	vec_ciphertext = mzd_add(NULL, vec_keystream, vec_message);
}


void print_data()
{
	myfile_en.open("/home/ishtiaq/quad/quad_output/quad_GF2/Encryption.txt");
	myfile_en<<"\t\t\t********Implementation of Encryption of Quad Stream Cipher using GF2 ********\n\n";

	myfile_en<<"Key\n(";
	for(int i=0;i<(n)-1;i++)
	{
	
		myfile_en<<bool(mzd_read_bit(vec_key,0,i));
			if((i+1)%4==0)
			myfile_en<<" ";
			if((i+1)%120==0)
			myfile_en<<"\n ";

	}

	myfile_en<<bool(mzd_read_bit(vec_key,0,n -1))<<")";
	myfile_en<<"\n\n";

	myfile_en<<"Message\n(";
	for(int i=0;i<(L*n)-1;i++)
	{
	
		myfile_en<<bool(mzd_read_bit(vec_message,0,i));
			if((i+1)%4==0)
			myfile_en<<" ";
			if((i+1)%120==0)
			myfile_en<<"\n ";

	}

	myfile_en<<bool(mzd_read_bit(vec_message,0,L*n -1))<<")";

	myfile_en<<"\n\n";

	myfile_en<<"Keystream vector\n(";
	for(int i=0;i<(L*n)-1;i++)
	{
	
		myfile_en<<bool(mzd_read_bit(vec_keystream,0,i));
			if((i+1)%4==0)
			myfile_en<<" ";
			if((i+1)%120==0)
			myfile_en<<"\n ";

	}

	myfile_en<<bool(mzd_read_bit(vec_keystream,0,L*n -1))<<")";

	myfile_en<<"\n\n";

	myfile_en<<"Ciphertext is\n(";
	for(int i=0;i<(L*n)-1;i++)
	{
	
		myfile_en<<bool(mzd_read_bit(vec_ciphertext,0,i));
			if((i+1)%4==0)
			myfile_en<<" ";
			if((i+1)%120==0)
			myfile_en<<"\n ";

	}

	myfile_en<<bool(mzd_read_bit(vec_ciphertext,0,L*n -1))<<")";
	myfile_en<<"\n\n";

}

/*
void store_data()
{
	myfile_en.open("/home/ishtiaq/quad/quad_data/quad_random_poly/key_IV_ciphertext.txt");
	
	myfile_en<<"n\n";
	myfile_en<<n<<endl;

	myfile_en<<"D\n";
	myfile_en<<D<<endl;

	myfile_en<<"L\n";
	myfile_en<<L<<endl;

	myfile_en<<"key\n";
	for(int j=0;j<n;j++)
		myfile_en<<key[j]<<" ";
	myfile_en<<endl;
	

	myfile_en<<"IV\n";
	for(int j=0;j<80;j++)
		myfile_en<<IV[j]<<" ";
	myfile_en<<endl;

	myfile_en<<"ciphertext\n";
	for(int j=0;j<L*n;j++)
		myfile_en<<ciphertext[j]<<" ";
	myfile_en<<endl;
	
	myfile_en.close();
	
	myfile_en.open("/home/ishtiaq/quad/quad_data/quad_random_poly/publicmaps.txt");
	
	myfile_en<<"P\n";
	for(int k=0;k<n;k++)
	{
		for(int j=0;j<D;j++)
			myfile_en<<matrix_P[k][j]<<" ";
	        myfile_en<<endl;
	}
	
	myfile_en<<"Q\n";
	for(int k=0;k<n;k++)
	{
		for(int j=0;j<D;j++)
			myfile_en<<matrix_Q[k][j]<<" ";
	        myfile_en<<endl;
	}
	
	myfile_en<<"S0\n";
	for(int k=0;k<n;k++)
	{
		for(int j=0;j<D;j++)
			myfile_en<<matrix_S0[k][j]<<" ";
	        myfile_en<<endl;
	}

	myfile_en<<"S1\n";
	for(int k=0;k<n;k++)
	{
		for(int j=0;j<D;j++)
			myfile_en<<matrix_S1[k][j]<<" ";
	        myfile_en<<endl;
	}
	
	myfile_en.close();
}
*/
