#include <m4ri/config.h>
#include <stdlib.h>
#include <m4ri/m4ri.h>
#include <m4ri/packedmatrix.h>
#include<sys/stat.h>
#include<sys/types.h>

#include "encryption.h"
#include "decryption.h"
#include "Timer1.h"

using namespace std;




int main() {

	Timer1 timer;
	char c;
	const int length=2;
	double time_measure[length];
	double *result_time=0;
        unsigned long long cpu_cycles[length];
        unsigned long long* result_cpu;
        unsigned long long cycles;

	cout<<"\n**********Implementation of QUAD stream cipher using random polynomials***********\n";
	
x:	cout<<"\nPlease enter the value of n (e.g 2 for small tests) ";
	cin>>n;
	
	cout<<"\nPlease enter the value of L (e.g 10 for small tests) ";
	cin>>L;
	
     	cout<<"\nIf you want change input press 'c',If you want to exit press 'e',\nelse press any alphabet to continue  ";
    	cin>>c;
	if(c=='c')
		goto x;
	if(c=='e')
		goto y;
	
	srandom(time(0));
	
	D=(n*(n+1))/2 + 1;

	mkdir("/home/ishtiaq/quad",0777);

	mkdir("/home/ishtiaq/quad/quad_output",0777);
	//mkdir("/home/ishtiaq/quad/quad_data",0777);

	mkdir("/home/ishtiaq/quad/quad_output/quad_GF2",0777);
	//mkdir("/home/ishtiaq/quad/quad_data/quad_random_poly",0777);
	
	cout<<"\nInitialising Public maps,Key,Initialisation vector and choosing random message of "<<(L*n)<<" bits....";
	initilize_quadraticSystem_key_IV();
	initialize_message();
	cout<<"Initialisation completed\n";

	cout<<"\nEncrypting ....";
	 
	timer.start();// Start the timer
	cpu_cycles[0] = rdtsc();
	keystream_generation(); 
        cpu_cycles[0] = rdtsc() - cpu_cycles[0];         
	timer.stop();// Stop the timer
        time_measure[0]=timer.getElapsedTimeInMilliSec();
	
	timer.start();// Start the timer
	cpu_cycles[1] = rdtsc();
	encryption();
        cpu_cycles[1] = rdtsc() - cpu_cycles[1];         
	timer.stop();// Stop the timer
        time_measure[1]=timer.getElapsedTimeInMilliSec();
	
	cout<<"Message encrypted\n";
	
	cout<<"Time Elapsed in  Milli-Seconds for Keystream generation using GF2\n";
	cout<<"Time: "<<time_measure[0];
	cout<<"\n\nNumber of Cpu Cycles used for Keystream generation using GF2\n";
	cout<<"Cpu Cycles: "<<cpu_cycles[0];	

	cout<<"\n\nTime Elapsed in  Milli-Seconds for Ciphertext generation using message and keystream\n";
	cout<<"Time: "<<time_measure[1];
	cout<<"\n\nNumber of Cpu Cycles used for Ciphertext generation using message and keystream\n";
	cout<<"Cpu Cycles: "<<cpu_cycles[1];

	cout<<"\n\n\nDecrypting ....";

	timer.start();// Start the timer
	cpu_cycles[0] = rdtsc(); 
	keystream_generation_decryption();
        cpu_cycles[0] = rdtsc() - cpu_cycles[0];         
	timer.stop();// Stop the timer
        time_measure[0]=timer.getElapsedTimeInMilliSec();

	timer.start();// Start the timer
	cpu_cycles[1] = rdtsc(); 
	decryption();
        cpu_cycles[1] = rdtsc() - cpu_cycles[1];         
	timer.stop();// Stop the timer
        time_measure[1]=timer.getElapsedTimeInMilliSec();
		
	
	cout<<"Message decrypted\n";
	cout<<"Time Elapsed in  Milli-Seconds for Keystream generation using GF2\n";
	cout<<"Time: "<<time_measure[0];
	cout<<"\n\nNumber of Cpu Cycles used for Keystream generation using GF2\n";
	cout<<"Cpu Cycles: "<<cpu_cycles[0];

	cout<<"\n\nTime Elapsed in  Milli-Seconds for Message generation using keystream and ciphertext\n";
	cout<<"Time: "<<time_measure[1];
	cout<<"\n\nNumber of Cpu Cycles used for Message generation using keystream and ciphertext\n";
	cout<<"Cpu Cycles: "<<cpu_cycles[1];

	cout<<"\n\nKey,Message,Keystream vector and ciphertext are written in \n/home/ishtiaq/quad/quad_output/quad_GF2/encryption.txt\n";	
	print_data();
	
	cout<<"\nDecrypted message is written in /home/ishtiaq/quad/quad_output/quad_GF2/decryption.txt\n";
	print_decrypted_message();
  	
	
	

	
	
	

	
/*
 int a;
 a=bool(c);
 cout<<"\n"<<c<<"\nhello";
 cout<<"llll\n"<<a<<"\nhahahmerejannn";
 bool d= mzd_read_bit(S0,0,1) ^ mzd_read_bit(S0,0,1);

 mzd_write_bit(S0, 0, 1, 0);

 cout<<"\nrefjflj"<<d<<endl;  

  BIT l =mzd_read_bit(S0,0,1); 
 int k;
 k=bool(l);
 cout<<"\n"<<l<<"\nhello";
 cout<<"llll\n"<<k<<"\nhahahmerejannn";

*/
y: return 0;

}
