#include "encryption.h"


using namespace std;

ofstream myfile_en;

int** matrix_P;
int** matrix_Q;
int** matrix_S0;
int** matrix_S1;

int* key;
int* IS;
int *message;	
int *keystream;
int *ciphertext;

bool IV[80];

int L;

void initilize_quadraticSystem_key_IV()
{

	matrix_P = new int *[n] ;//memory allocated for elements of rows.
		
	for( int i = 0 ; i < n; i++ )//memory allocated for  elements of each column.
		matrix_P[i] = new int[D];
	
	randvalformatrix(n,D,matrix_P);

	matrix_Q = new int *[n] ;//memory allocated for elements of rows.
		
	for( int i = 0 ; i < n; i++ )//memory allocated for  elements of each column.
		matrix_Q[i] = new int[D];
	
	randvalformatrix(n,D,matrix_Q);

	matrix_S0 = new int *[n] ;//memory allocated for elements of rows.
		
	for( int i = 0 ; i < n; i++ )//memory allocated for  elements of each column.
		matrix_S0[i] = new int[D];
	
	randvalformatrix(n,D,matrix_S0);

	matrix_S1 = new int *[n] ;//memory allocated for elements of rows.
		
	for( int i = 0 ; i < n; i++ )//memory allocated for  elements of each column.
		matrix_S1[i] = new int[D];
	
	randvalformatrix(n,D,matrix_S1);

	key =new int[n];
	randvectorgenerator(n,key);

	for(int i=0;i<80;i++)
		IV[i]=rand()%2;

}
void initialize_message()
{	
	L=20;
	message=new int[n*L];

	for(int i=0;i<(n*L);i++)
	{
		message[i]=rand()%256;
		
	}
	
}
void preprocessing()
{
	IS =new int[n];
	for(int i=0;i<n;i++)
		IS[i]=key[i];

	for(int i=0;i<80;i++)
	{
		if (IV[i]==0)
			polnomial_evaluation(matrix_S0,IS);
		else
			polnomial_evaluation(matrix_S1,IS);			
		
	}

	for(int i=0;i<80;i++)
		polnomial_evaluation(matrix_P,IS);

	
}


void keystream_generation()
{	
	
	keystream =new int[(L*n)];
	
	for(int i=0;i<L;i++)
	{
		polnomial_evaluation(matrix_Q,IS);
		
		for(int j=0;j<n;j++)
			keystream[i*n+j]=IS[j];
		
		polnomial_evaluation(matrix_P,IS);
	}
	
}
void encryption()
{
	preprocessing();
	keystream_generation();
	
	ciphertext =new int[L*n];

	for(int i=0;i<(L*n);i++)
		ciphertext[i]=keystream[i]^message[i];

	

}
void print_data()
{
	myfile_en.open("/home/ishtiaq/quad/quad_output/quad_random_poly/Encryption.txt");
	myfile_en<<"\t\t\t********Implementation of Encryption of Quad Stream Cipher using random polynomials********\n\n";

	myfile_en<<"Key\n(";
	for(int i=0;i<(n)-1;i++)
		myfile_en<<key[i]<<",";
	
	myfile_en<<key[n-1]<<")";
	myfile_en<<"\n\n";

	myfile_en<<"Message\n(";
	for(int i=0;i<(L*n)-1;i++)
	{
		myfile_en<<message[i]<<",";
		if((i+1)%48==0)
		myfile_en<<"\n";
	}

	myfile_en<<message[L*n-1]<<")";
	myfile_en<<"\n\n";
	
	myfile_en<<"Keystream vector\n(";
	for(int i=0;i<(L*n)-1;i++)
	{
		myfile_en<<keystream[i]<<",";
		if((i+1)%48==0)
		myfile_en<<"\n";
	}
	myfile_en<<keystream[L*n-1]<<")";
	myfile_en<<"\n\n";
	
	myfile_en<<"Ciphertext\n(";
	for(int i=0;i<(L*n)-1;i++)
	{
		myfile_en<<ciphertext[i]<<",";
		if((i+1)%48==0)
		myfile_en<<"\n";
	}
	myfile_en<<ciphertext[L*n-1]<<")";
	myfile_en<<"\n\n";
	myfile_en.close();
}
void store_data()
{
	myfile_en.open("/home/ishtiaq/quad/quad_data/quad_random_poly/key_IV_ciphertext.txt");
	
	myfile_en<<"n\n";
	myfile_en<<n<<endl;

	myfile_en<<"D\n";
	myfile_en<<D<<endl;

	myfile_en<<"L\n";
	myfile_en<<L<<endl;

	myfile_en<<"key\n";
	for(int j=0;j<n;j++)
		myfile_en<<key[j]<<" ";
	myfile_en<<endl;
	

	myfile_en<<"IV\n";
	for(int j=0;j<80;j++)
		myfile_en<<IV[j]<<" ";
	myfile_en<<endl;

	myfile_en<<"ciphertext\n";
	for(int j=0;j<L*n;j++)
		myfile_en<<ciphertext[j]<<" ";
	myfile_en<<endl;
	
	myfile_en.close();
	
	myfile_en.open("/home/ishtiaq/quad/quad_data/quad_random_poly/publicmaps.txt");
	
	myfile_en<<"P\n";
	for(int k=0;k<n;k++)
	{
		for(int j=0;j<D;j++)
			myfile_en<<matrix_P[k][j]<<" ";
	        myfile_en<<endl;
	}
	
	myfile_en<<"Q\n";
	for(int k=0;k<n;k++)
	{
		for(int j=0;j<D;j++)
			myfile_en<<matrix_Q[k][j]<<" ";
	        myfile_en<<endl;
	}
	
	myfile_en<<"S0\n";
	for(int k=0;k<n;k++)
	{
		for(int j=0;j<D;j++)
			myfile_en<<matrix_S0[k][j]<<" ";
	        myfile_en<<endl;
	}

	myfile_en<<"S1\n";
	for(int k=0;k<n;k++)
	{
		for(int j=0;j<D;j++)
			myfile_en<<matrix_S1[k][j]<<" ";
	        myfile_en<<endl;
	}
	
	myfile_en.close();
}

