// Ishtiaqcourage.cpp : Defines the entry point for the console application.
//

#include "basic.h"
#include "signvericyclic.h"
#include "Timer1.h"
#include<sys/stat.h>
#include<sys/types.h>



using namespace std;



int main() 
{	
	Timer1 timer;
	char c;
	const int length=1000;
	double time_measure[length];
	double *result_time=0;
        unsigned long long cpu_cycles[length];
        unsigned long long* result_cpu;
        unsigned long long cycles;

	cout<<"\n**********Implementation of Signature Verification of Cyclic Rainbow Scheme***********\n";
	


	

	srand((unsigned)time(0));
	
    	load_key_sign_hash();

	cout<<"\nSignature Verification ...\n";

	for(int i=0;i<length;i++)
	{   
		timer.start();// Start the timer
		cpu_cycles[i] = rdtsc(); 
    		signverificationcyclic();
                cpu_cycles[i] = rdtsc() - cpu_cycles[i];           
		timer.stop();// Stop the timer
                time_measure[i]=timer.getElapsedTimeInMicroSec();
               
	}
	
	if(result==1)
		cout<<"Authenticated\n";
	else
		cout<<"Failed\n";
	
	result_time=ave_max_min(time_measure,length);
	cout<<"Time Elapsed in  Micro-Seconds for Signature Verification\n";
	cout<<"Average Time: "<<result_time[0]<<"\nMaximum Time: "<<result_time[1]<<"\nMinimum Time: "<<result_time[2];
        
	result_cpu=ave_max_min_cpu(cpu_cycles,length);
	cout<<"\n\nNumber of Cpu Cycles used for Signature Verification\n";
	cout<<"Average Cpu Cycles: "<<result_cpu[0]<<"\nMaximum Cpu Cycles: "<<result_cpu[1]<<"\nMinimum Cpu Cycles: "<<result_cpu[2];	
		
	
	
	cout<<"\nWriting the Hash values generated by verification process and Result of \nSignature Verification in home\\ishtiaq\\rainbow\\rainbow_cyclic_output\\Signature Verification ...\n";
	print_signatureverification(result);
	cout<<"Completed\n";
	
	return 0;
}




 


