//============================================================================
// Name        : Verification.cpp
// Author      : Albrecht Petzoldt
// Version     :
// Copyright   :
// Description : Verification process of UOV and Rainbow over GF(16)
//============================================================================

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <cstdlib>
#include <ctime>
#include <fstream>
#include "Timer1.h"
using namespace std;

int** B; // matrix B
int oil;
int vinegar;
int vinegar2;
int vinegar3;
int nvar;
int D;
int choice1;
int choice2;
int* Gamma;
int oil1;
int oil2;
int*** MP;
int** MPK;
int* sign;

int lookup[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
                  10, 11, 12, 13, 14, 15, 0, 2, 4, 6, 8, 10, 12, 14, 3, 1, 7, 5, 11, 9, 15, 13, 0,
                  3, 6, 5, 12, 15, 10, 9, 11, 8, 13, 14, 7, 4, 1, 2, 0, 4, 8, 12, 3, 7, 11, 15, 6,
                  2, 14, 10, 5, 1, 13, 9, 0, 5, 10, 15, 7, 2, 13, 8, 14, 11, 4, 1, 9, 12, 3, 6, 0,
                  6, 12, 10, 11, 13, 7, 1, 5, 3, 9, 15, 14, 8, 2, 4, 0, 7, 14, 9, 15, 8, 1, 6, 13,
                  10, 3, 4, 2, 5, 12, 11, 0, 8, 3, 11, 6, 14, 5, 13, 12, 4, 15, 7, 10, 2, 9, 1, 0,
                  9, 1, 8, 2, 11, 3, 10, 4, 13, 5, 12, 6, 15, 7, 14, 0, 10, 7, 13, 14, 4, 9, 3,
                  15, 5, 8, 2, 1, 11, 6, 12, 0, 11, 5, 14, 10, 1, 15, 4, 7, 12, 2, 9, 13, 6, 8, 3,
                  0, 12, 11, 7, 5, 9, 14, 2, 10, 6, 1, 13, 15, 3, 4, 8, 0, 13, 9, 4, 1, 12, 8, 5,
                  2, 15, 11, 6, 3, 14, 10, 7, 0, 14, 15, 1, 13, 3, 2, 12, 9, 7, 6, 8, 4, 10, 11,
                  5, 0, 15, 13, 2, 9, 6, 4, 11, 1, 14, 12, 3, 8, 7, 5, 10 };

unsigned long long rdtsc(void)
{
  unsigned long long int x;
     __asm__ volatile (".byte 0x0f, 0x31" : "=A" (x));
     return x;
}
double* ave_max_min(double time[],int number)
{


	static double result_time[3];
	result_time[0]=0;
	result_time[1]=0;
	result_time[2]=10000000;


	for(int i=0;i<number;i++)
        {
	  result_time[0]=result_time[0] + time[i];

	  if(result_time[1]<=time[i])
		result_time[1]=time[i];


	  if(result_time[2]>=time[i])
		result_time[2]=time[i];

	}
	result_time[0]=result_time[0]/(double)number;
	return result_time;


}
unsigned long long* ave_max_min_cpu(unsigned long long cpucycles[],int number)
{
	 static unsigned long long result[3];
	 result[0]=0;
	 result[1]=0;
	 result[2]=1000000000;

	for(int i=0;i<number;i++)
        {
	  result[0]=result[0] + cpucycles[i];

	  if(result[1]<=cpucycles[i])
		result[1]=cpucycles[i];


	  if(result[2]>=cpucycles[i])
		result[2]=cpucycles[i];

	}
	result[0]=result[0]/number;

	return result;

}

void generate_MPK()
{
MPK= new int *[oil];
	for (int i=0; i< oil; i++)
	MPK[i]= new int[D];

	for (int i=0; i< oil; i++){
		for (int j=0;j<D;j++)
			MPK[i][j]=(rand()%16);
	}
}

void generate_MPcyclic()
{
	MP = new int **[oil]; // Speicher allokieren
	for (int i = 0; i < oil; i++) {
	    		MP[i] = new int*[nvar+1];
			for (int j = 0; j < (nvar+1); j++)
	      			MP[i][j] = new int[nvar+1];

		}
	for (int k=0; k<oil; k++){ // lower triangular
		for(int i=0; i<nvar; i++ ){
			for (int j=0; j<i; j++)
				MP[k][i][j]=0;
		}
	}

	// First polynomial
	for (int i=0; i<nvar; i++){
		for(int j=i; j<nvar; j++)
			MP[0][i][j]=(rand()%16);
	}

	// polynomials 2 - oil
	for (int k=1; k<oil; k++){
		MP[k][0][0]=MP[k-1][vinegar-1][nvar-1];
		for (int j=1; j<nvar; j++)// first row
			MP[k][0][j]=MP[k-1][0][j-1];
		for (int i=1; i<vinegar; i++){
			MP[k][i][i]=MP[k-1][i-1][nvar-1];
			for (int j=i+1; j<nvar; j++)
				MP[k][i][j]=MP[k-1][i][j-1];
		}
		for (int i=vinegar; i<nvar; i++){
			for (int j=i; j<nvar;j++)
				MP[k][i][j]=(rand()%16);
		}
	}
}

void generate_MPRbcyclic()
{
	MP = new int **[oil]; // Speicher allokieren
	for (int i = 0; i < oil; i++) {
	    		MP[i] = new int*[nvar+1];
			for (int j = 0; j < (nvar+1); j++)
	      			MP[i][j] = new int[nvar+1];

		}
	for (int k=0; k<oil; k++){ // lower triangular
		for(int i=0; i<nvar; i++ ){
			for (int j=0; j<i; j++)
				MP[k][i][j]=0;
		}
	}

	// First polynomial
	for (int i=0; i<nvar; i++){
		for(int j=i; j<nvar; j++)
			MP[0][i][j]=(rand()%16);
	}

	// first layer
	for (int k=1; k<=oil1; k++){
		MP[k][0][0]=MP[k-1][vinegar-1][vinegar2-1];
		for (int j=1; j<vinegar2; j++)// first row
			MP[k][0][j]=MP[k-1][0][j-1];
		for (int j=vinegar2; j<nvar;j++)
			MP[k][0][j]= (rand()%16);

		for (int i=1; i<vinegar; i++){
			MP[k][i][i]=MP[k-1][i-1][vinegar2-1];
			for (int j=i+1; j<vinegar2; j++)
				MP[k][i][j]=MP[k-1][i][j-1];
			for (int j=vinegar2; j<nvar;j++)
				MP[k][i][j]= (rand()%16);
		}

		for (int i=vinegar; i<nvar; i++){
			for (int j=i; j<nvar;j++)
				MP[k][i][j]=(rand()%16);
		}
	}
	// second layer

		for (int k=oil1+1; k<oil; k++){
			MP[k][0][0]=MP[k-1][vinegar2-1][nvar-1];
			for (int j=1; j<nvar; j++)// first row
				MP[k][0][j]=MP[k-1][0][j-1];

			for (int i=1; i<vinegar2; i++){
				MP[k][i][i]=MP[k-1][i-1][nvar-1];
				for (int j=i+1; j<nvar; j++)
					MP[k][i][j]=MP[k-1][i][j-1];
			}

			for (int i=vinegar2; i<nvar; i++){
				for (int j=i; j<nvar;j++)
					MP[k][i][j]=(rand()%16);
			}
		}
}


void generate_MP()

{

MP = new int **[oil]; // Speicher allokieren
for (int i = 0; i < oil; i++) {
    		MP[i] = new int*[nvar+1];
		for (int j = 0; j < (nvar+1); j++)
      			MP[i][j] = new int[nvar+1];

	}

for (int i=0;i<oil;i++){ // upper triangular (random)
	for (int j=0;j<nvar; j++){
		for (int k=j; k< nvar; k++){
			MP[i][j][k]=(rand()%16);
		}
	}

	for (int j=0;j<nvar;j++){ // lower triangular (zero)
		for (int k=0; k<j; k++){
			MP[i][j][k]=0;
		}
	}
}
}

void print_MP()
{
for (int k=0; k< oil; k++){
	for (int i=0; i< nvar; i++){
		for (int j=0; j<nvar; j++){
			cout << MP[k][i][j] << "\t";
		}
	cout << endl;}
	cout << endl;}
}

void print_MPK()
{
for (int i=0; i<oil; i++){
	for (int j=0; j<D; j++){
		cout << MPK[i][j] << "\t";
	}
cout << endl;
}
cout << endl;
}


void verify(int* sign)
{
	int* hash= new int [oil];
	int* temp= new int [nvar];

for (int i=0; i< oil; i++){
  	hash[i]=0;
	for (int j=0; j<nvar; j++){
		temp[j]=0;
		for (int k=0; k<=j; k++){
			temp[j]=temp[j]^ lookup[MP[i][k][j]*16+sign[k]];
		}
	}
	for (int j=0; j<nvar; j++){
		hash[i]=hash[i]^lookup[temp[j]*16+sign[j]];
		}
}

}

void verifyMPK(int* sign)
{
int* hash= new int [oil];
int counter=0;
int* mon =new int[D]; // vector mon
	for (int i=0; i<nvar;i++){
		for (int j=i; j<nvar; j++){
			mon[counter]=lookup[sign[i]*16+sign[j]];
			counter++;
			}
	}
	for (int i=0; i<nvar; i++){
		mon[counter]=sign[i];
		counter++;
	}


for (int i=0; i<oil; i++)
{
	hash[i]=0;
	counter=0;
	for (int j=0; j<nvar; j++){
		for(int k=j; k<nvar; k++){
			hash[i]=hash[i] ^ lookup[mon[counter]*16+MPK[i][counter]];
			counter ++;
		}
	}
	for (int j=0; j< nvar; j++){
		hash[i]=hash[i] ^ lookup[mon[counter]*16+MPK[i][counter]];
		counter ++;
	}

}
}
void verifycyclic(int* sign)
{
	int* hash= new int [oil];
 	int* temp= new int [nvar];
 	int* a= new int[nvar];

 	// first polynomial
  	hash[0]=0;
	for (int i=0; i<vinegar; i++){
		a[i]=0;
		for (int j=0; j<=i; j++) // vector temp
		a[i]= a[i] ^ lookup[MP[0][j][i]*16+sign[j]];
		temp[i]=a[i];
	}
	for (int i=vinegar; i<nvar-1; i++){
		a[i]=0;
		for (int j=0; j<vinegar; j++)
			a[i]=a[i] ^ lookup[MP[0][j][i]*16+sign[j]];
		temp[i]=a[i];
		for (int j = vinegar; j<=i; j++)
			temp[i]=temp[i] ^lookup[MP[0][j][i]*16+sign[j]];
		}
	temp[nvar-1]=0;
	for (int j=0; j<nvar; j++)
		temp[nvar-1]=temp[nvar-1] ^lookup[MP[0][j][nvar-1]*16+ sign[j]];

	for (int j=0; j<nvar; j++){ // hash value
		hash[0]=hash[0]^lookup[temp[j]*16+sign[j]];
		}

	for(int k=1; k< oil;k++){ // polynomials 2 - o
	hash[k]=0;

		for (int i=nvar-1; i>=vinegar; i--){ // vector temp
			a[i]=a[i-1];
			temp[i]=a[i];
			for(int j=vinegar; j<=i; j++)
				temp[i]=temp[i] ^ lookup[MP[k][j][i]*16+sign[j]];
		}
		for (int i =vinegar-1; i>=1;i--){
			a[i]=a[i-1] ^lookup [MP[k][i][i]*16+sign[i]];
			temp[i]=a[i];
		}
		a[0]=lookup[MP[k][0][0]*16+sign[0]];
		temp[0]=a[0];

		for (int j=0; j<nvar; j++){ // hash value
			hash[k]=hash[k]^lookup[temp[j]*16+sign[j]];
			}
	}

}


void verifyRbcyclic(int* sign)
{
	int* hash= new int [oil];
 	int* temp= new int [nvar];
 	int* a= new int[nvar];

 	// first polynomial
  	hash[0]=0;
	for (int i=0; i<vinegar; i++){
		a[i]=0;
		for (int j=0; j<=i; j++) // vector temp
		a[i]= a[i] ^ lookup[MP[0][j][i]*16+sign[j]];
		temp[i]=a[i];
	}
	for (int i=vinegar; i<vinegar2; i++){
		a[i]=0;
		for (int j=0; j<vinegar; j++)
			a[i]=a[i] ^ lookup[MP[0][j][i]*16+sign[j]];
		temp[i]=a[i];
		for (int j = vinegar; j<=i; j++)
			temp[i]=temp[i] ^lookup[MP[0][j][i]*16+sign[j]];
	}

	for (int i=vinegar2; i<nvar; i++){
		temp[i]=0;
		for (int j=0; j<i; j++)
			temp[i]=temp[i] ^lookup[MP[0][j][i]*16+ sign[j]];
	}

	for (int j=0; j<nvar; j++){ // hash value
		hash[0]=hash[0]^lookup[temp[j]*16+sign[j]];
		}
//-------------------------------------------------------------------------------
	for(int k=1; k< oil1;k++){ // first layer
	hash[k]=0;

		for (int i=nvar-1; i>=vinegar2; i--){
			temp[i]=0;
			for (int j=1; j<=i; j++)
				temp[i]=temp[i] ^ lookup[MP[k][j][i] *16+ sign[j]];
		}

		for (int i=vinegar2-1; i>=vinegar; i--){
			a[i]=a[i-1];
			temp[i]=a[i];
			for(int j=vinegar; j<=i; j++)
				temp[i]=temp[i] ^ lookup[MP[k][j][i]*16+sign[j]];
		}

		for (int i =vinegar-1; i>=1;i--){
			a[i]=a[i-1] ^lookup [MP[k][i][i]*16+sign[i]];
			temp[i]=a[i];
		}

		a[0]=lookup[MP[k][0][0]*16+sign[0]];
		temp[0]=a[0];

		for (int j=0; j<nvar; j++){ // hash value
			hash[k]=hash[k]^lookup[temp[j]*16+sign[j]];
		}
	}
//--------------------------------------------------------------------------
		// first polynomial of second layer
		hash[oil1]=0;


			for (int i=nvar-1; i>=vinegar2; i--){
				a[i]=0;
				for(int j=0; j < vinegar2; j++)
					a[i]=a[i] ^ lookup[MP[oil1][j][i]*sign[j]];
					temp[i]=a[i];
				for(int j=vinegar2; j<=i; j++)
					temp[i]=temp[i] ^ lookup[MP[oil1][j][i]*16+sign[j]];
			}

			for (int i=vinegar2-1; i>=vinegar; i--){
				a[i]=a[i-1];
				for (int j=vinegar; j<=i; j++)
					a[i]=a[i]^lookup[MP[oil1][j][i]*16+sign[j]];
				temp[i]=a[i];
			}

			for (int i =vinegar-1; i>=1;i--){
				a[i]=a[i-1] ^lookup [MP[oil1][i][i]*16+sign[i]];
				temp[i]=a[i];
			}
			a[0]=lookup[MP[oil1][0][0]*16+sign[0]];
			temp[0]=a[0];

			for (int j=0; j<nvar; j++){ // hash value
				hash[oil1]=hash[oil1]^lookup[temp[j]*16+sign[j]];
			}
			//------------------------------------------------------------------

			for (int k=oil1+1; k< oil; k++){ // Remaining polynomials of second layer
					hash[k]=0;

						for (int i=nvar-1; i>=vinegar2; i--){
							a[i]=a[i-1];
							temp[i]=a[i];
							for (int j =vinegar2; j<=i; j++)
								temp[i]=temp[i] ^ lookup[MP[k][j][i]*16+sign[j]];
						}

						for (int i=vinegar2-1; i>=1; i--){
							a[i]=a[i-1] ^ lookup[MP[k][i][i]*16+sign[i]];
							temp[i]=a[i];
						}

						a[0]=lookup[MP[k][0][0]*16+sign[0]];
						temp[0]=a[0];

						for (int j=0; j<nvar; j++){ // hash value
							hash[k]=hash[k]^lookup[temp[j]*16+sign[j]];
						}
			}

}



int main() {
	Timer1 timer;
	srand((unsigned)time(0));
	const int number=10000;
	double time_measure[number];
		double *result_time=0;
	        unsigned long long cpu_cycles[number];
	        unsigned long long* result_cpu;
	        //unsigned long long cycles;

	cout << "Enter 1 for UOV and 2 for Rainbow" << endl;
	cin >> choice1;



if(choice1==1){
	cout << "***UOV over GF(16)***" << endl;
	cout << "Enter 1 for random polynomials with the standard approach" << endl << "2 for random polynomials with the alternative approach," << endl << "and 3 for cyclic polynomials:";
		cin >> choice2;
	cout << "v:";
		cin >> vinegar;
		cout << "o:";
		cin >> oil;
		nvar=oil+vinegar;
		D= (nvar+1)*(nvar+2)/2-1;}
	if(choice1==2){
	cout << "***Rainbow***" << endl;
	cout << "Enter 1 for random polynomials with the standard approach" << endl << "2 for random polynomials with the alternative approach," << endl << "and 3 for cyclic polynomials:";
		cin >> choice2;
	cout << "v1:";
		cin >> vinegar;
		cout << "o1:";
		cin >> oil1;
		cout << "o2:";
		cin >> oil2;
		oil=oil1+oil2;
		nvar=oil+vinegar;
		vinegar2=vinegar+oil1;
		D= (nvar+1)*(nvar+2)/2-1;}
		sign=new int[nvar];

		if (choice2==1){ // standard approach
			generate_MPK();
					//print_MPK();

				 for(int i=0;i<number;i++)
					{
					 for (int j=0; j<nvar; j++){
					 	 	 sign[j]=(rand()%16);
					 	 }
						timer.start();// Start the timer
						cpu_cycles[i] = rdtsc();
						verifyMPK(sign);


							 cpu_cycles[i] = rdtsc() - cpu_cycles[i];
							 timer.stop();// Stop the timer
				             time_measure[i]=timer.getElapsedTimeInMicroSec();
				         }
				}

	if (choice2==2){ // possibility 2
		generate_MP();
		//print_MP();

	 for(int i=0;i<number;i++)
		{
		 for (int j=0; j<nvar; j++)
		 	 sign[j]=(rand()%16);

			timer.start();// Start the timer
			cpu_cycles[i] = rdtsc();
			verify(sign);
				 cpu_cycles[i] = rdtsc() - cpu_cycles[i];
			timer.stop();// Stop the timer
	                time_measure[i]=timer.getElapsedTimeInMicroSec();

		}
	}


	if (choice2==3 and choice1==1){ // UOV with cyclic polynomials
				generate_MPcyclic();
				//print_MP();

			for(int i=0;i<number; i++)
				{
				 for (int j=0; j<nvar; j++)
				 	 sign[j]=(rand()%16);

				 timer.start();// Start the timer
					cpu_cycles[i] = rdtsc();
					//verify(sign);
					verifycyclic(sign);
						 cpu_cycles[i] = rdtsc() - cpu_cycles[i];
					timer.stop();// Stop the timer
			                time_measure[i]=timer.getElapsedTimeInMicroSec();

				}
			}


	if (choice2==3 and choice1==2){//Rainbowcyclic
						generate_MPRbcyclic();
						//print_MP();

						for(int i=0;i<number;i++)
												{
												for (int j=0; j<nvar; j++){
												 	 sign[j]=(rand()%16);
												 }
												timer.start();// Start the timer
												cpu_cycles[i] = rdtsc();
												//verify(sign);

												verifyRbcyclic(sign);
												cpu_cycles[i] = rdtsc() - cpu_cycles[i];
												timer.stop();// Stop the timer
												time_measure[i]=timer.getElapsedTimeInMicroSec();
											}
		}

		result_time=ave_max_min(time_measure,number);
		cout<<"Time Elapsed in  Micro-Seconds for Signature Verification\n";
		cout<<"Average Time: "<<result_time[0]<<"\nMaximum Time: "<<result_time[1]<<"\nMinimum Time: "<<result_time[2];
		result_cpu=ave_max_min_cpu(cpu_cycles,number);
		cout<<"\n\nNumber of Cpu Cycles used for Signature Verification\n";
		cout<<"Average Cpu Cycles: "<<result_cpu[0]<<"\nMaximum Cpu Cycles: "<<result_cpu[1]<<"\nMinimum Cpu Cycles: "<<result_cpu[2];

		return 0;
}
